## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global commit 1445333280272d42cf3dcf6ce850bafa83b51543
%global snapdate 20250308

Name:           dr_libs
# While the individual header-only libraries are versioned, the overall
# collection is not, and there are no releases. These libraries follow the
# general practices of stb, so see also:
#   https://github.com/nothings/stb/issues/359
#   https://github.com/nothings/stb/issues/1101
%global snapinfo ^%{snapdate}git%{sub %{commit} 1 7}
Version:        0%{snapinfo}
Release:        %autorelease
Summary:        Single-file audio decoding libraries for C/C++

URL:            https://github.com/mackron/dr_libs
# See LICENSE.
License:        Unlicense OR MIT-0

%global dr_flac_version 0.12.44
%global dr_mp3_version 0.7.0
%global dr_wav_version 0.14.0

Source:        %{url}/archive/%{commit}/dr_libs-%{commit}.tar.gz

BuildRequires:  cmake
BuildRequires:  gcc-c++

# For tests:
BuildRequires:  pkgconfig(flac)
BuildRequires:  libsndfile-devel

# No compiled binaries are installed, so this would be empty.
%global debug_package %{nil}

%description
%{summary}.


%package devel
Summary:        Development files for dr_libs

BuildArch:      noarch

# Dependent packages should prefer to BuildRequire the -static packages for the
# specific dr_libs libraries they use.
Provides:       dr_libs-static = %{version}-%{release}

Requires:       dr_flac-devel = %{dr_flac_version}%{snapinfo}-%{release}
Requires:       dr_flac-static = %{dr_flac_version}%{snapinfo}-%{release}
Requires:       dr_mp3-devel = %{dr_mp3_version}%{snapinfo}-%{release}
Requires:       dr_mp3-static = %{dr_mp3_version}%{snapinfo}-%{release}
Requires:       dr_wav-devel = %{dr_wav_version}%{snapinfo}-%{release}
Requires:       dr_wav-static = %{dr_wav_version}%{snapinfo}-%{release}

%description devel
The dr_libs-devel package contains libraries and header files for developing
applications that use dr_libs.

This is a metapackage that requires the -devel packages for all dr_libs
libraries.


%package -n dr_flac-devel
Summary:        FLAC audio decoder
Version:        %{dr_flac_version}%{snapinfo}

BuildArch:      noarch

Provides:       dr_flac-static = %{dr_flac_version}%{snapinfo}-%{release}

%description -n dr_flac-devel
FLAC audio decoder.


%package -n dr_mp3-devel
Summary:        MP3 audio decoder
Version:        %{dr_mp3_version}%{snapinfo}

BuildArch:      noarch

Provides:       dr_mp3-static = %{dr_mp3_version}%{snapinfo}-%{release}

%description -n dr_mp3-devel
MP3 audio decoder. Based off minimp3 (https://github.com/lieff/minimp3).


%package -n dr_wav-devel
Summary:        WAV audio loader and writer
Version:        %{dr_wav_version}%{snapinfo}

BuildArch:      noarch

Provides:       dr_wav-static = %{dr_wav_version}%{snapinfo}-%{release}

%description -n dr_wav-devel
WAV audio loader and writer.


%package doc
Summary:        Documentation for dr_libs

BuildArch:      noarch

%description doc
Documentation for dr_libs.


%prep
%autosetup -n dr_libs-%{commit}

# Omit the "playback" tests. We cannot run these anyway, so we would hae to
# skip them, and by not even compiling them, we can avoid a BuildRequires on
# miniaudio.
sed -r -i 's/^([[:blank:]]*)(.*_playback)/\1# \2/' CMakeLists.txt

mkdir -p tests/testvectors/mp3/tests


%conf
%cmake -DDR_LIBS_BUILD_TESTS:BOOL=ON


%build
%cmake_build


%install
# There are no install targets in CMakeLists.txt, so %%cmake_install would do
# nothing. We install manually instead:
install -t '%{buildroot}%{_includedir}' -p -m 0644 -D dr_*.h


%check
skips='^($.'
# Fails with “No output file specified.”
skips="${skips}|wav_encoding"
# These require files in tests/testvectors/mp3/tests/ that are not distributed:
skips="${skips}|mp3_(basic|extract)"
skips="${skips})$"

%ctest --exclude-regex "${skips}"

# As a sanity check, verify that all of the subpackage version numbers appear
# in the corresponding headers.
while read -r version header
do
  grep -E "\\bv$(echo "${version}" | sed -r 's/\./\\./g')\\b" \
      "%{buildroot}%{_includedir}/${header}" >/dev/null
done <<'EOF'
%{dr_flac_version} dr_flac.h
%{dr_mp3_version} dr_mp3.h
%{dr_wav_version} dr_wav.h
EOF


%files devel
# Empty metapackage


%files doc
%license LICENSE
%doc README.md


%files -n dr_flac-devel
%license LICENSE
%{_includedir}/dr_flac.h


%files -n dr_mp3-devel
%license LICENSE
%{_includedir}/dr_mp3.h


%files -n dr_wav-devel
%license LICENSE
%{_includedir}/dr_wav.h


%changelog
## START: Generated by rpmautospec
* Sun Mar 09 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20250308git1445333-1
- Update to 0^20250308git1445333
- New CMake build system for tests, and redesigned tests overall
- dr_flac 0.12.44: Fix compilation for AIX OS.
- dr_mp3 0.7.0: BREAKING API CHANGES and multiple fixes.
- dr_wav 0.14.0: BREAKING API CHANGE: some members of `drwav_cue_point`
  renamed

* Thu Jan 16 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0^20241216git660795b-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Dec 17 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20241216git660795b-1
- Update to 0^20241216git660795b
- dr_flac 0.12.43: Fix a possible buffer overflow during decoding. Improve
  detection of ARM64EC.
- dr_mp3 0.6.40: Improve detection of ARM64EC
- dr_wav 0.13.17: Fix a possible crash when reading from MS-ADPCM encoded
  files. Improve detection of ARM64EC.

* Thu Dec 12 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20240226gitda35f9d-4
- Add a SourceLicense field

* Wed Jul 17 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0^20240226gitda35f9d-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Tue Feb 27 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20240226gitda35f9d-1
- Update to 0^20240226gitda35f9d (dr_wav 0.13.15, dr_mp3 0.6.39, dr_flac
  0.12.42)

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0^20230806gitd35a3bc-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0^20230806gitd35a3bc-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Tue Oct 10 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20230806gitd35a3bc-1
- Update to 0^20230806gitd35a3bc (dr_mp3 0.6.37, dr_wav 0.13.12)

* Tue Oct 10 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20230617git056b6f5-3
- Fedora, EPEL9+: drop the initial “0.” from the Release

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0^20230617git056b6f5-0.2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sat Jun 17 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20230617git056b6f5-0.1
- Update to 056b6f5 (dr_wav 0.13.10, dr_mp3 0.6.36, dr_flac 0.12.41)

* Sat Jun 03 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20230522gitc2e2189-0.2
- Remove explicit %%set_build_flags, not needed since F36

* Thu May 25 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20230522gitc2e2189-0.1
- Update to c2e2189 (dr_wav 0.13.9, dr_mp3 0.6.35, dr_flac 0.12.40)

* Wed Apr 12 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20230324git4b3d078-0.1
- Update to 4b3d078 (dr_wav 0.13.8)

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0^20220917gitdd762b8-0.3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Sun Sep 18 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20220917gitdd762b8-0.2
- Fix missing source

* Sun Sep 18 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20220917gitdd762b8-0.1
- Update to dd762b8 (dr_flac 0.12.39, dr_mp3 0.6.34, dr_wav 0.13.7)

* Wed Aug 31 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20220410git15f37e3-0.4
- Fix SSE4.1 instructions generated on x86_64

* Sun Jul 31 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20220410git15f37e3-0.3
- Update License field to SPDX

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0^20220410git15f37e3-0.2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Wed Apr 20 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0^20220410git15f37e3-0.1
- Drop “forge” macros to switch to modern snapshot versioning

* Sun Apr 10 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.16
- Update to 15f37e3 (dr_flac 0.12.38, dr_mp3 0.6.33, dr_wav 0.13.6)

* Thu Mar 31 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.15
- Update to c72913 (dr_flac 0.12.37)

* Mon Feb 07 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.14
- Missing parts of previous commit

* Mon Feb 07 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.13
- Update to 1e42667

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0-0.12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Jan 07 2022 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.11
- Update to 4aff565 (dr_flac 0.12.34)

* Wed Dec 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.10
- Update to c5e5355 (dr_mp3 0.6.32, dr_flac 0.12.33)

* Thu Dec 16 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.9
- Let the -devel packages be noarch

* Wed Dec 08 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.8
- Update to 49de65c (dr_wav 0.13.4)

* Wed Nov 24 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.7
- Restore missing sintel_trailer-audio.flac source

* Wed Nov 24 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.6
- Update to 4a108a8 (dr_wav 0.13.3)

* Sat Oct 02 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.5
- Update to f13cbcf (dr_wav 0.13.2)

* Fri Sep 24 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.4
- Update to 8900af1 with dr_mp3 0.6.31

* Fri Sep 24 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.3
- Reduce macro indirection in spec file

* Tue Aug 17 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.2
- Improved patch for flac seeking tests from upstream

* Tue Aug 17 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0-0.1
- Initial package
## END: Generated by rpmautospec
